/* user include file for dmem library interface */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>
#include "mpi.h"

#define  DMEM_VERSION             DMEM
#define  DMEM_VERSION_NUMBER      144
#define  DMEM_VERSION_DATE        17-Jul-2018

#define DMEM_HANDLE_SIZE 3

#define DMEM_SUCCESS     0

typedef MPI_Aint dmem_handle[DMEM_HANDLE_SIZE];

int DMEM_Init(MPI_Comm, MPI_Aint, int);
int DMEM_Finalize();
int DMEM_Put(void *, MPI_Aint, dmem_handle);
int DMEM_Get(dmem_handle, void *);
int DMEM_Get_part(dmem_handle, MPI_Aint, MPI_Aint, void *);
int DMEM_Copy(dmem_handle, dmem_handle);
int DMEM_Update(dmem_handle, MPI_Aint, MPI_Aint, void *);
int DMEM_Free(dmem_handle);
int DMEM_Abort(int);
int DMEM_Dumpglobmemtab();
int DMEM_Dumplocmemtab();
int DMEM_Print_handle(dmem_handle);
char * DMEM_Sprint_handle(dmem_handle);
int DMEM_Stats_snapshot();
int DMEM_Stats_final();		/* obsolete, merged into finalize */
int DMEM_Get_server(dmem_handle);
MPI_Aint DMEM_Get_address(dmem_handle);
MPI_Aint DMEM_Get_size(dmem_handle);
int DMEM_Set_errors_return(int);
/* void DMEM_p(int, char *, ...); replaced by macro defining either empty or as DMEM_P_fcn */
void DMEM_p_fcn(int, char *, ...);
