/* -*- Mode: C; c-basic-offset:4 ; indent-tabs-mode:nil ; -*- */
/*
 *  (C) 2015 by Argonne National Laboratory.
 *      See COPYRIGHT in top-level directory.
 */

/* rmbmac */
/*
#if defined(__clang__)
#    define F77_NAME_LOWER_2USCORE
#endif
*/

/* BG/Q */
#if defined(__bgp__) || defined(__bgq__)  ||  defined(__bg__)
#    define F77_NAME_LOWER
#endif

/*

Define one of the names below if needed.  Default: no #defines apply.

 */
#if defined(F77_NAME_UPPER)
#define dmem_init_ DMEM_INIT
#define dmem_put_  DMEM_PUT
#define dmem_get_  DMEM_GET
#define dmem_copy_ DMEM_COPY
#define dmem_update_  DMEM_UPDATE
#define dmem_get_part_ DMEM_GET_PART
#define dmem_free_  DMEM_FREE
#define dmem_finalize_ DMEM_FINALIZE
#define dmem_abort_ DMEM_ABORT
#define dmem_get_server_ DMEM_GET_SERVER
#define dmem_get_address_ DMEM_GET_ADDRESS
#define dmem_get_size_ DMEM_GET_SIZE
#define dmem_dumpglobmemtab_ DMEM_DUMPGLOBMEMTAB
#define dmem_dumplocmemtab_ DMEM_DUMPLOCMEMTAB
#define dmem_print_handle_ DMEM_PRINT_HANDLE
#define dmem_stats_snapshot_ DMEM_STATS_SNAPSHOT
#define dmem_stats_final_ DMEM_STATS_FINAL
#define dmem_set_errors_return_ DMEM_SET_ERRORS_RETURN
#elif defined(F77_NAME_LOWER_2USCORE)
#define dmem_init_ dmem_init__
#define dmem_put_ dmem_put__
#define dmem_get_ dmem_get__
#define dmem_copy_ dmem_copy__
#define dmem_update_ dmem_update__
#define dmem_get_part_ dmem_get_part__
#define dmem_free_ dmem_free__
#define dmem_finalize_ dmem_finalize__
#define dmem_abort_ dmem_abort__
#define dmem_get_server_ dmem_get_server__
#define dmem_get_address_ dmem_get_address__
#define dmem_get_size_ dmem_get_size__
#define dmem_dumpglobmemtab_ dmem_dumpglobmemtab__
#define dmem_dumplocmemtab_ dmem_dumplocmemtab__
#define dmem_print_handle_ dmem_print_handle__
#define dmem_stats_snapshot_ dmem_stats_snapshot__
#define dmem_stats_final_ dmem_stats_final__
#define dmem_set_errors_return_ dmem_set_errors_return__
#elif defined(F77_NAME_LOWER)
#define dmem_init_ dmem_init
#define dmem_put_ dmem_put
#define dmem_get_ dmem_get
#define dmem_copy_ dmem_copy
#define dmem_update_ dmem_update
#define dmem_get_part_ dmem_get_part
#define dmem_free_ dmem_free
#define dmem_finalize_ dmem_finalize
#define dmem_abort_ dmem_abort
#define dmem_get_server_ dmem_get_server
#define dmem_get_address_ dmem_get_address
#define dmem_get_size_ dmem_get_size
#define dmem_dumpglobmemtab_ dmem_dumpglobmemtab
#define dmem_dumplocmemtab_ dmem_dumplocmemtab
#define dmem_print_handle_ dmem_print_handle
#define dmem_stats_snapshot_ dmem_stats_snapshot
#define dmem_stats_final_ dmem_stats_final
#define dmem_set_errors_return_ dmem_set_errors_return
#endif

#include "dmem.h"

void dmem_init_(MPI_Comm *user_comm, MPI_Aint *memsize, int *num_recvs, int *ierr);
void dmem_init_(MPI_Comm *user_comm, MPI_Aint *memsize, int *num_recvs, int *ierr)
{
    *ierr = DMEM_Init(*user_comm, *memsize, *num_recvs);
}

void dmem_finalize_(int *ierr);
void dmem_finalize_(int *ierr)
{
    *ierr = DMEM_Finalize();
}

void dmem_put_(void *pkg_addr, MPI_Aint *pkg_len, dmem_handle dh, int *ierr);
void dmem_put_(void *pkg_addr, MPI_Aint *pkg_len, dmem_handle dh, int *ierr)
{
    *ierr = DMEM_Put(pkg_addr, *pkg_len, dh);
}

void dmem_get_(dmem_handle dh, void *buf_addr, int *ierr);
void dmem_get_(dmem_handle dh, void *buf_addr, int *ierr)
{
    *ierr = DMEM_Get(dh, buf_addr);
}
void dmem_copy_(dmem_handle dh, dmem_handle dh2, int *ierr);
void dmem_copy_(dmem_handle dh, dmem_handle dh2, int *ierr)
{
    *ierr = DMEM_Copy(dh, dh2);
}
void dmem_free_(dmem_handle dh, int *ierr);
void dmem_free_(dmem_handle dh, int *ierr)
{
    *ierr = DMEM_Free(dh);
}
void dmem_abort_(int *abort_code, int *ierr);
void dmem_abort_(int *abort_code, int *ierr)
{
    *ierr = DMEM_Abort(*abort_code);
}
void dmem_get_part_(dmem_handle dh, MPI_Aint *offset, MPI_Aint *length, void *buf_addr, int *ierr);
void dmem_get_part_(dmem_handle dh, MPI_Aint *offset, MPI_Aint *length, void *buf_addr, int *ierr)
{
    *ierr = DMEM_Get_part(dh, *offset-1, *length, buf_addr); /* adjust offset for fortran */
}
void dmem_update_(dmem_handle dh, MPI_Aint *offset, MPI_Aint *length, void *buf_addr, int *ierr);
void dmem_update_(dmem_handle dh, MPI_Aint *offset, MPI_Aint *length, void *buf_addr, int *ierr)
{
    *ierr = DMEM_Update(dh, *offset-1, *length, buf_addr);   /* adjust offset for fortran */
}
int dmem_get_server_(dmem_handle dh);
int dmem_get_server_(dmem_handle dh)
{
    return DMEM_Get_server(dh);
}
MPI_Aint dmem_get_address_(dmem_handle dh);
MPI_Aint dmem_get_address_(dmem_handle dh)
{
    return DMEM_Get_address(dh);
}
MPI_Aint dmem_get_size_(dmem_handle dh);
MPI_Aint dmem_get_size_(dmem_handle dh)
{
    return DMEM_Get_size(dh);
}
void dmem_dumpglobmemtab_(int *ierr);
void dmem_dumpglobmemtab_(int *ierr)
{
    *ierr = DMEM_Dumpglobmemtab();
}
void dmem_dumplocmemtab_(int *ierr);
void dmem_dumplocmemtab_(int *ierr)
{
    *ierr = DMEM_Dumplocmemtab();
}
void dmem_print_handle_(dmem_handle dh, int *ierr);
void dmem_print_handle_(dmem_handle dh, int *ierr)
{
    *ierr = DMEM_Print_handle(dh);
}
void dmem_stats_snapshot_(int *ierr);
void dmem_stats_snapshot_(int *ierr)
{
    *ierr = DMEM_Stats_snapshot();
}
void dmem_stats_final_(int *ierr);
void dmem_stats_final_(int *ierr)
{
    *ierr = DMEM_Stats_final(); /* obsolete, merged into finalize */
}
void dmem_set_errors_return_(int *value, int *ierr);
void dmem_set_errors_return_(int *value, int *ierr)
{
    *ierr = DMEM_Set_errors_return(*value);
}
